%Normal modes
%Assume sound speed is independent of depth. Introduce dampening by having
%a complex sound speed. 

%Boundary for R should be rigid cylinder, i.e. dR/dr = 0, r = a (a is
%radius for cylinder), and for the surface at z = L, (L = level), 

%Chapter 2.7 in marine acoustics
%[delta^2 + k(r)]*PHI(r,w) = - F(r)

%Homogenous Helmholtz equation in cylindrical coordinates s 30.

%Separation
%PHI(r,z,w) = PHIr(r,w)*PHIz(z,w)
%Vertical wave number = y(z) = w / c * sin theta(z)
%Horisontal wave number k = w/c * cos theta(z)

%Solution of depth-part (PHIz) is (given independent speed of sound)
%PHIz(z,w) = A*e^(iyz) + B*e^(-iyz), where A and B are given by boundary
%condtitions. I will set these to PHIz(L) = 0, and dPHIz/dz(0) = 0.

%The range equation however, is a bit more bitch:
% PHIr = A0*J0(k*r)+B0*Y0(k*r), boundary conditions ==>  dR/dr = 0, r=+-a.
%When r = 0, PHIr(r,w) = A0*J0(kr)
%J0 and Y0 given at page 33. 

%Coustyx approach
clear all
%dim Rr
a = 1;
L = 6;
%Coustyx 
syms kr
syms r
syms R(r) 
syms m


DR = diff(R);

%eqR = dsolve(diff(R,2)+(1/r)*diff(R)+((kr)^2 - m^2/r^2)*R == 0);
%C4 and C5 found by trial and error to match documentation
% C4 = 1;
% C5 = 0;

%Marine acoustics approach
eqR = dsolve(diff(R,2)+(1/r)*diff(R)+((kr)^2)*R == 0,DR(a) == 0);
C6 = 1;


eqR = simplify(eqR);
neqR = diff(eqR,'r');
neqR = subs(neqR,r,a);

neqR = subs(neqR);
Rr = matlabFunction(neqR);

%Plotting to see where zeroes are
% yVal = [];
% xVal = [];
% for i=1:0.01:100
%     yVal = [yVal;Rr(i)];
%     xVal = [xVal;i];
% end
% plot(xVal,yVal)
% hold on
% plot(xVal,zeros(1,length(yVal)),'r')

dim_n = 15;
dim_m = 6;
x0 = 1.5;
val = zeros(dim_n,dim_m);
% for m=1:dim_m
%     x0 = (m-1)+1;
%     for j=1:dim_n
%         val(j,m) = fsolve(@(kr)Rr(kr,m-1),x0);
%         x0 = x0 + 3;
%     end
% end

%The depth equation:
%d^2Z/dz^2+kz*Z = 0
%Boundary: dZ/dz = 0, z = 0, Z = 0, z = L.
%
syms z
syms Z(z)
syms kz
DZ = diff(Z);
eqZ = dsolve(diff(Z,2)+kz^2*Z(z) == 0); 
% C9 = 1/2;
% eqZ = subs(eqZ);
% eqZ = simplify(eqZ);
% Zz = matlabFunction(eqZ);

% Calculate Roots of Zz.
% dim_nz = 15;
% kz_roots = zeros(1,dim_nz);
% for i=1:dim_nz
%     kz_roots = cos(
%Lets try this skeet






























