clear all
close all

%Path is relative to the directory of this m-file.
path ='New data\Attenuation noBound\Adb_32_4p_1MHz_30v_noBound_5-30cm_us_signal.txt';
w_path = 'Results\Attenuation';


data = dlmread(path);
st_noise = 700;
data = data(:,st_noise:end);
mes_nr = size(data,1);
data = normalize(data);

ampl_max = zeros(1,mes_nr);
max_pos = zeros(1,mes_nr);
for i=1:mes_nr
    figure(1)
    [ampl_max(i),max_pos(i)] = max(data(i,:));
%     plot(data(i,:))
%     axis([0 size(data,2)-st_noise -0.5 0.5])
%     hold on
%     plot(max_pos(i),ampl_max(i),'r+')
%     pause(0.1)
%     hold off
end
%Convert samples to m. Obvousley sampled at 16.67 MHz
max_pos_d = 1/(16.67e6) * (max_pos+st_noise-90) *1630;
%Convert m to cm
max_pos_d = 100*max_pos_d;

%========================= ATTENUATION COEFFICIENT ========================
%Curve fitting for some distance
d = 0.2;
a_s = 0.01:0.001:0.1;
tot_err = [];
%find distance index
ind = 0;
for i=1:length(max_pos_d)
    if max_pos_d > d
        ind = i;
        break
    end
end
curve = ampl_max(ind:end);
A0 = max(ampl_max);
for i=1:length(a_s)
   tmp_err = 0;
   for k=1:length(curve)
       tmp_err = tmp_err + abs(curve(k)-A0*exp(-a_s(i)*max_pos_d(ind+k-1)));
   end
   tot_err = [tot_err;tmp_err];
end
[m,i] = min(tot_err);

figure(3)
plot(max_pos_d,ampl_max)
hold on
plot(max_pos_d,A0*exp(-a_s(i).*max_pos_d),'r')
a_s(i)



%Plot relative dampening.
TL = 10*log10(A0./ampl_max);
figure(4)
plot(max_pos_d,TL)
hold on

%Theoretical attenuation
web_a = 0.0022.*max_pos_d*1;
att = web_a.*max_pos_d*1;
spread = 15*log(max_pos_d./max_pos_d(1));
spread_and_att = att+spread;
plot(max_pos_d,att,'r')
hold on
plot(max_pos_d,spread_and_att,'g')

%========================== SPHERICAL SPREADING ===========================
r = 0.06:0.01:0.6;
lambda = 1630/1e6;
a = 0.005;
beam_width = 2*lambda/(pi*a);

%ampl_TL = A0*(r(1)./r)*D;
ampl_TL1 = A0*r(1)./r;
ampl_TL2 = A0*2*r(1)./r;

figure(5)
plot(max_pos_d,ampl_max)
hold on
plot(r*100,ampl_TL1,'r')
hold on
plot(r*100,ampl_TL2,'g')

%=========================== LOMMELS EQUATION =============================
%Approx of LommeLs: spherical after rayleigh distance.
ACTUAL_TL = 10*log10(ampl_max./A0);

z = max_pos_d:0.5:70;
k = 8;
S_TL = -10*log10(z(1)+k)+10*log10((z+k));
A_TL = (0.0022).*z;
T_TL = (S_TL+A_TL);

N = a^2/lambda;

figure(6)
plot(max_pos_d,ACTUAL_TL)
hold on
plot(z,-T_TL+T_TL(1),'r')
hold on
% plot(z,-S_TL+S_TL(1),'g')
% hold on
plot(z,-A_TL,'cy')

%Theoretical
%figure(7)

%============================= CONSTANT DIST =============================
path ='New data\Attenuation noBound\Adb_32_4p_1MHz_30v_noBound_30cm_us_signal.txt';


data = dlmread(path);
st_noise = 700;
data = data(:,st_noise:end);
mes_nr = size(data,1);
data = normalize(data);

ampl_max = zeros(1,mes_nr);
max_pos = zeros(1,mes_nr);
for i=1:mes_nr
    figure(1)
    [ampl_max(i),max_pos(i)] = max(data(i,:));
    plot(data(i,:))
    axis([0 size(data,2)-st_noise -0.7 0.7])
    hold on
    plot(max_pos(i),ampl_max(i),'r+')
    pause(0.1)
    hold off
end
%Convert samples to m. Obvousley sampled at 16.67 MHz
max_pos_d = 1/(16.67e6) * (max_pos+st_noise-90) *1630;
%Convert m to cm
max_pos_d = 100*max_pos_d;

median(max_pos_d);
median(ampl_max);

% % %Write results to file
% res = [median(ampl_max);median(max_pos_d)];
% % % disp('distance in samples to maximums')
% % % 
% dlmwrite([w_path '\' name],res);

points = [0.655;0.3477;0.24;0.19;0.13];
dist = [11.28;17.99;28.6;39.8;50.2];

z = dist(1):0.5:70;
k = 3;
S_TL = -10*log10(z(1)+k)+10*log10((z+k));
figure(7)
plot(dist,10*log10(points/points(1)))
hold on
plot(z,-S_TL+S_TL(1),'r')