clear all,close all
% % import test-set
path = 'New data\Vibration\';
filename_us = 'vib_test_10Hz_15hz_40Hz_5Hz_24_03_us_signal2.txt';
filename_trig = 'vib_test_10Hz_15hz_40Hz_5Hz_24_03_us_trig2.txt';

us_data = dlmread([path filename_us]);
us_trig = dlmread([path filename_trig]);
disp('files read')
l = size(us_data,1);
sample_l = size(us_data,2);

%========================= SEPARATE BASED ON TRIG =========================
%Triggs
bad_trigs = [];
trig_580kHz = [];
trig_1MHz_50_50 = [];
trig_1MHz_30_70 = [];

for k = 1:l
    trig_type = identify_trig(us_trig(k,:));
    if strcmp(trig_type,'580kHz')
        trig_580kHz  = [trig_580kHz;k];
    elseif strcmp(trig_type,'1MHz4_50_50')
        trig_1MHz_50_50 = [trig_1MHz_50_50;k];
    elseif strcmp(trig_type,'1MHz4_30_70')
        trig_1MHz_30_70 = [trig_1MHz_30_70;k];
    else
        trig_type
        k
        plot(us_trig(k,:))
        bad_trigs = [bad_trigs;k];
    end
end
disp('separated triggs')

%Extract measurement based on triggs
[us_data_580kHz,us_data_1MHz_50_50,us_data_1MHz_30_70] = sep_mes_by_trig(us_data,trig_580kHz,trig_1MHz_50_50,trig_1MHz_30_70);
disp('separated measurements based on triggs')

% Plotting to check behavior of identify trig
% for k = 1:size(trig_580kHz,1)
%     figure(1)
%     plot(us_data_580kHz(k,:))
%     pause(0.2)
% end
% 
% for k = 1:size(trig_1MHz_50_50,1)
%     figure(1)
%     plot(us_data_1MHz_50_50(k,:))
%     pause(0.2)
% end
    
%========================= PRE-PROCESSING =================================
%=========== START UP NOISE ==========
st_noise = 700;
us_data_580kHz = remove_stnoise(st_noise,us_data_580kHz);
us_data_1MHz_50_50 = remove_stnoise(st_noise,us_data_1MHz_50_50);
us_data_1MHz_30_70 = remove_stnoise(st_noise,us_data_1MHz_30_70);
disp('removed startup noise')

us_data_580kHz_n = normalize(us_data_580kHz);
us_data_1MHz_50_50_n = normalize(us_data_1MHz_50_50);
us_data_1MHz_30_70_n = normalize(us_data_1MHz_30_70);
disp('normalization done')

% Average start
% us_data_pr = us_data_n;
% us_data_pr_580kHz = average_measurement2(us_data_580kHz_n,2); 
% 
% for k = 1:size(us_data_pr_580kHz,1)
%     figure(1)
%     plot(us_data_pr_580kHz(k,2000:4000))
%     pause(0.2)
% end
%============================ FIND ECHOS ==================================

var_limit_580kHz = 0.0001;
[~,echo_ind_580kHz,RTT_ind_580kHz,RTT_vals_580kHz,var_580kHz,disc_mes_580kHz] = find_echos_and_RTT(us_data_580kHz_n,var_limit_580kHz,st_noise);
disp('580 kHz done')
var_limit_1MHz_50_50 = 0.0001;
[~,echo_ind_1MHz_50_50,RTT_ind_1MHz_50_50,RTT_vals_1MHz_50_50,var_1MHz_50_50,disc_mes_1MHz_50_50] = find_echos_and_RTT(us_data_1MHz_50_50_n,var_limit_1MHz_50_50,st_noise);
disp('1MHz 50/50 done')
var_limit_1MHz_30_70 = 0.0001;
[~,echo_ind_1MHz_30_70,RTT_ind_1MHz_30_70,RTT_vals_1MHz_30_70,var_1MHz_30_70,disc_mes_1MHz_30_70] = find_echos_and_RTT(us_data_1MHz_30_70_n,var_limit_1MHz_30_70,st_noise);
disp('1MHz 30/70 done')


RTT_ind_580kHz(:,1) = (1/14.3e+6).*RTT_ind_580kHz(:,1).*1630/2;
RTT_ind_580kHz(:,1) = RTT_ind_580kHz(:,1)*100;
figure(1)
plot(RTT_ind_580kHz(:,2),RTT_ind_580kHz(:,1),'bo')
%hleg1 = legend('Measured level');
hold on
plot(disc_mes_580kHz,mean(RTT_ind_580kHz(:,1))*ones(length(disc_mes_580kHz),1),'ro')
hleg1 = legend('Measured level','discarded measurements');
ylabel('Level in [cm]')
xlabel('Measurement number')
title('Vibration bench test with 580 kHz trigger')

RTT_ind_1MHz_50_50(:,1) = (1/14.3e+6).*RTT_ind_1MHz_50_50(:,1).*1630/2;
RTT_ind_1MHz_50_50(:,1) = RTT_ind_1MHz_50_50(:,1)*100;
figure(2)
plot(RTT_ind_1MHz_50_50(:,2),RTT_ind_1MHz_50_50(:,1),'bo')
hold on
plot(disc_mes_1MHz_50_50,mean(RTT_ind_1MHz_50_50(:,1))*ones(length(disc_mes_1MHz_50_50),1),'ro')
hleg2 = legend('Measured level','discarded measurements');
ylabel('Level in [cm]')
xlabel('Measurement number')
title('Vibration bench test with 1MHz 50/50 trigger')

RTT_ind_1MHz_30_70(:,1) = (1/14.3e+6).*RTT_ind_1MHz_30_70(:,1).*1630/2;
RTT_ind_1MHz_30_70(:,1) = RTT_ind_1MHz_30_70(:,1)*100;
figure(3)
plot(RTT_ind_1MHz_30_70(:,2),RTT_ind_1MHz_30_70(:,1),'bo')
hold on
plot(disc_mes_1MHz_30_70,mean(RTT_ind_1MHz_30_70(:,1))*ones(length(disc_mes_1MHz_30_70),1),'ro')
hleg3 = legend('Measured level','discarded measurements');
ylabel('Level in [cm]')
xlabel('Measurement number')
title('Vibration bench test with 1MHz 30/70 trigger')

figure(4)
plot(echo_ind_580kHz(:,2),echo_ind_580kHz(:,1),'LineWidth',2)
hold on
plot(disc_mes_580kHz,mean(echo_ind_580kHz(:,1))*ones(length(disc_mes_580kHz),1),'r+')

figure(5)
plot(echo_ind_1MHz_50_50(:,2),echo_ind_1MHz_50_50(:,1),'LineWidth',2)
hold on
plot(disc_mes_1MHz_50_50,mean(echo_ind_1MHz_50_50(:,1))*ones(length(disc_mes_1MHz_50_50),1),'r+')

figure(6)
plot(echo_ind_1MHz_30_70(:,2),echo_ind_1MHz_30_70(:,1),'LineWidth',2)
hold on
plot(disc_mes_1MHz_30_70,mean(echo_ind_1MHz_30_70(:,1))*ones(length(disc_mes_1MHz_30_70),1),'r+')

figure(7)
plot(var_580kHz)
axis([0 5200 0 10e-3])
ylabel('variance')
hleg4 = legend('Variance');
xlabel('Measurement number')
title('Vibration bench test variance 580 kHz trigger')

figure(8)
plot(var_1MHz_50_50)
axis([0 5200 0 10e-3])
ylabel('variance')
hleg4 = legend('Variance');
xlabel('Measurement number')
title('Vibration bench test variance 1MHz 50/50 trigger')

figure(9)
plot(var_1MHz_30_70)
axis([0 5200 0 10e-3])
ylabel('variance')
hleg4 = legend('Variance');
xlabel('Measurement number')
title('Vibration bench test variance 1MHz 30/70 trigger')

figure(10)
plot(31.92-RTT_ind_580kHz(:,1),'b+')
xlabel('Measurements')
ylabel('Error [cm]')
